(ns clj-in-act.ch11.dsl-store
  "Listing 11.3: The dsl-store namespace for storing the rules as anonymous functions")

(def RULES (ref {}))

(defn register-segment [segment-name segment-fn]
  (dosync
    (alter RULES assoc-in [:segments segment-name] segment-fn)))

(defn segment-named [segment-name]
  (get-in @RULES [:segments segment-name]))

(defn all-segments []
  (:segments @RULES))
